/*
 * $Id: Parameters.cpp 146 2011-02-01 20:57:54Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Generic/RegisterFile/include/Parameters.h"

namespace morpheo {
namespace behavioural {
namespace generic {
namespace registerfile {


  Parameters::Parameters (morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::Parameters * param)
  {
    log_printf(FUNC,RegisterFile,"Parameters","Begin");

    _instance          = instance_RegisterFile_Monolithic;
    _nb_port_read      = param->_nb_port_read ;
    _nb_port_write     = param->_nb_port_write;
    _nb_word           = param->_nb_word      ; 
    _size_word         = param->_size_word    ; 
    _size_address      = param->_size_address ;
    _have_port_address = param->_have_port_address;

    _param_registerfile_monolithic      = param;
    _param_registerfile_internal_banked = NULL;
    _param_registerfile_multi_banked    = NULL;

    test();

    log_printf(FUNC,RegisterFile,"Parameters","End");
  };

  Parameters::Parameters (morpheo::behavioural::generic::registerfile::registerfile_internal_banked  ::Parameters * param)
  {
    log_printf(FUNC,RegisterFile,"Parameters","Begin");

    _instance          = instance_RegisterFile_Internal_Banked;
    _nb_port_read      = param->_nb_port_read ;
    _nb_port_write     = param->_nb_port_write;
    _nb_word           = param->_nb_word      ; 
    _size_word         = param->_size_word    ; 
    _size_address      = param->_size_address ;
    _have_port_address = param->_have_port_address;

    _param_registerfile_monolithic      = NULL;
    _param_registerfile_internal_banked = param;
    _param_registerfile_multi_banked    = NULL;

    test();

    log_printf(FUNC,RegisterFile,"Parameters","End");
  };

  Parameters::Parameters (morpheo::behavioural::generic::registerfile::registerfile_multi_banked::Parameters * param) :
    _instance (instance_RegisterFile_Multi_Banked),
    _nb_port_read      (param->_nb_port_read ),
    _nb_port_write     (param->_nb_port_write),
    _nb_word           (param->_nb_word      ), 
    _size_word         (param->_size_word    ), 
    _size_address      (param->_size_address ),
    _have_port_address (param->_have_port_address)
  {
    log_printf(FUNC,RegisterFile,"Parameters","Begin");

    _param_registerfile_monolithic      = NULL;
    _param_registerfile_internal_banked = NULL;
    _param_registerfile_multi_banked    = param;

    test();

    log_printf(FUNC,RegisterFile,"Parameters","End");
  };
  
  Parameters::~Parameters () 
  {
    log_printf(FUNC,RegisterFile,"~Parameters","Begin");
    log_printf(FUNC,RegisterFile,"~Parameters","End");
  };

  void Parameters::copy (void) 
  {
    log_printf(FUNC,RegisterFile,"copy","Begin");

    throw ERRORMORPHEO("RegisterFile::copy",_("Invalid copy"));

//     if (_instance == instance_RegisterFile_Monolithic)
//       COPY(_param_registerfile_monolithic);
//     if (_instance == instance_RegisterFile_Internal_Banked)
//       COPY(_param_registerfile_internal_banked);
//     if (_instance == instance_RegisterFile_Multi_Banked)
//       COPY(_param_registerfile_multi_banked);
    
    log_printf(FUNC,RegisterFile,"copy","End");
  };

}; // end namespace registerfile
}; // end namespace generic
}; // end namespace behavioural
}; // end namespace morpheo              
